function [ positionError ] = positionError( endEffectorPosition )
% Calculates the position error to use in position controller
%   Position should be in circle

x = endEffectorPosition(1);
y = endEffectorPosition(2);



% Circle in xz - plane
circleRadius = 0.4;
xCenter = 0.6; 
yCenter = 0;

dist = sqrt((x-xCenter)^2 + (y-yCenter)^2); 

if (dist == circleRadius)
    xerr = 0; 
    yerr = 0; 
else 
    factor = circleRadius/dist;
    xerr = (factor - 1)*x; 
    yerr = (factor - 1)*y;
end
    
    





% Combining
positionError = [xerr; yerr];

