%%% File to connect to V-REP and get the necessary handles %%%

%Connection to V-REP
vrep=remApi('remoteApi'); % using the prototype file (remoteApiProto.m)
vrep.simxFinish(-1); % just in case, close all opened connections
clientID = vrep.simxStart('129.241.154.70',19997,true,true,5000,5)


% Specifying synchronous mode
[returnCode] = vrep.simxSynchronous(clientID,1); % Enable the synchronous mode (Blocking function call)
[returnCode] = vrep.simxStartSimulation(clientID,vrep.simx_opmode_oneshot);

%Triggering first simulation initialization step
[returnCode] = vrep.simxSynchronousTrigger(clientID); % Trigger next simulation step (Blocking function call)


% Get all handles
[returnCode, UR5] = vrep.simxGetObjectHandle(clientID, 'UR5', vrep.simx_opmode_oneshot_wait);
% Reference frame relative to
[returnCode, CoordinateFrame] = vrep.simxGetObjectHandle(clientID, 'UR5_link1_visible', vrep.simx_opmode_oneshot_wait);


% Joints
[returnCode, joint1] = vrep.simxGetObjectHandle(clientID, 'UR5_joint1', vrep.simx_opmode_oneshot_wait);
[returnCode, joint2] = vrep.simxGetObjectHandle(clientID, 'UR5_joint2', vrep.simx_opmode_oneshot_wait);
[returnCode, joint3] = vrep.simxGetObjectHandle(clientID, 'UR5_joint3', vrep.simx_opmode_oneshot_wait);
[returnCode, joint4] = vrep.simxGetObjectHandle(clientID, 'UR5_joint4', vrep.simx_opmode_oneshot_wait);
[returnCode, joint5] = vrep.simxGetObjectHandle(clientID, 'UR5_joint5', vrep.simx_opmode_oneshot_wait);
[returnCode, joint6] = vrep.simxGetObjectHandle(clientID, 'UR5_joint6', vrep.simx_opmode_oneshot_wait);

% Links
[returnCode, link2] = vrep.simxGetObjectHandle(clientID, 'UR5_link2', vrep.simx_opmode_oneshot_wait);
[returnCode, link3] = vrep.simxGetObjectHandle(clientID, 'UR5_link3', vrep.simx_opmode_oneshot_wait);
[returnCode, link4] = vrep.simxGetObjectHandle(clientID, 'UR5_link4', vrep.simx_opmode_oneshot_wait);
[returnCode, link5] = vrep.simxGetObjectHandle(clientID, 'UR5_link5', vrep.simx_opmode_oneshot_wait);
[returnCode, link6] = vrep.simxGetObjectHandle(clientID, 'UR5_link6', vrep.simx_opmode_oneshot_wait);
[returnCode, link7] = vrep.simxGetObjectHandle(clientID, 'UR5_link7', vrep.simx_opmode_oneshot_wait);


% Controller variables
inInts = [link2 link3 link4 link5 link6 link7];