function [ positionError ] = positionError( endEffectorPosition )
% Calculates the position error to use in position controller
%   Position should be in circle

x = endEffectorPosition(1);
y = endEffectorPosition(2);
z = endEffectorPosition(3);

% Error in y
yref = -0.6;
yerr = yref - y;


% Circle in xz - plane
circleRadius = 0.25;
xCenter = 0; 
zCenter = 0.5;

dist = sqrt((x-xCenter)^2 + (z-zCenter)^2); 

if (dist == circleRadius)
    xerr = 0; 
    zerr = 0; 
else 
    factor = circleRadius/dist;
    xerr = (factor - 1)*x; 
    zerr = (factor - 1)*z;
end
    
    





% Combining
positionError = [xerr yerr zerr];


end

