% UR5 Kinematics

% Rotation Matrices
R01 = [cos(theta1) 0 sin(theta1); ...
    sin(theta1) 0 -cos(theta1); ...
    0 1 0]; 
R12 = [cos(theta2) -sin(theta2) 0; ...
    sin(theta2) cos(theta2) 0; ...
    0 0 1]; 
R23 = [cos(theta3) -sin(theta3) 0; ...
    sin(theta3) cos(theta3) 0; ...
    0 0 1]; 
R34 = [cos(theta4) 0 sin(theta4); ...
    sin(theta4) 0 -cos(theta4); ...
    0 1 0]; 
R45 = [cos(theta5) 0 sin(theta5); ...
    sin(theta5) 0 -cos(theta5); ...
    0 1 0]; 
R56 = [cos(theta6) -sin(theta6) 0; ...
    sin(theta6) cos(theta6) 0; ...
    0 0 1]; 


% Translation vectors
o01 = [0; 0; 0.089]; 
o12 = [-0.425*cos(theta3); -0.425*sin(theta3); 0]; 
o23 = [-0.392*cos(theta4); -0.392*sin(theta3); 0]; 
o34 = [0; 0; 0.109];
o45 = [0; 0; 0.095]; 
o56 = [0; 0; 0.082];

% Transformation matrices
A1 = [R01 o01; [0 0 0] 1]; 
A2 = [R12 o12; [0 0 0] 1]; 
A3 = [R23 o23; [0 0 0] 1]; 
A4 = [R34 o34; [0 0 0] 1]; 
A5 = [R45 o45; [0 0 0] 1]; 
A6 = [R56 o56; [0 0 0] 1];

T06 = A1*A2*A3*A4*A5*A6;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analytic Jacobian

Jg = calcJg(jointPos, d, a);
R = T06(1:3,1:3); 


theta = atan2(R(3,3), sqrt(1-(R(3,3)^2))); 
if ((R(1,3) == 0) && (R(2,3) == 0)) 
    phi = 0; 
    if(R(3,3) == 1)
        psi = atan2(R(1,1),R(2,1));
    end
    if(R(3,3) == -1)
        psi = atan2(-R(1,1), -R(1,2)); 
     
    end
else
    phi = atan2(R(1,3), R(2,3)); 
    psi = atan2(-R(3,1), R(3,2));
end
        

o06 = T06(1:3,4); 
beta06 = [phi; theta; psi];

X = [o06; beta06];

B = [cos(psi)*sin(theta) -sin(psi) 0; ...
    sin(psi)*sin(theta) cos(psi) 0; ...
    cos(theta) 0 1];

Ja = [eye(3) zeros(3,3); zeros(3,3) B.^-1]*Jg;
    


